diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_trace.c ircd-hybrid-7-bg/modules/m_trace.c
--- ircd-hybrid-7rc5/modules/m_trace.c	Wed Sep  4 21:10:24 2002
+++ ircd-hybrid-7-bg/modules/m_trace.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_trace.c,v 1.51 2002/09/05 01:10:24 db Exp $
+ *  $Id: m_trace.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -40,6 +40,7 @@
 #include "msg.h"
 #include "parse.h"
 #include "modules.h"
+#include "s_misc.h"
 
 
 static void m_trace(struct Client *, struct Client *, int, char **);
@@ -68,7 +69,7 @@
   hook_del_event("doing_trace");
   mod_del_cmd(&trace_msgtab);
 }
-const char *_version = "$Revision: 1.51 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 static int report_this_status(struct Client *source_p, struct Client *target_p,int dow,
                               int link_u_p, int link_u_s);
@@ -89,7 +90,7 @@
     tname = parv[1];
   else
     tname = me.name;
-  sendto_one(source_p, form_str(RPL_ENDOFTRACE), me.name, parv[0], tname);
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFTRACE), me.name, parv[0], tname);
 }
 
 
@@ -130,10 +131,10 @@
         
         ac2ptr = next_client_double(GlobalClientList, tname);
         if (ac2ptr)
-          sendto_one(source_p, form_str(RPL_TRACELINK), me.name, looking_for,
+          sendto_one(source_p, form_str(source_p,RPL_TRACELINK), me.name, looking_for,
                      ircd_version, debugmode, tname, ac2ptr->from->name);
         else
-          sendto_one(source_p, form_str(RPL_TRACELINK), me.name, looking_for,
+          sendto_one(source_p, form_str(source_p,RPL_TRACELINK), me.name, looking_for,
                      ircd_version, debugmode, tname, "ac2ptr_is_NULL!!");
         return;
       }
@@ -168,7 +169,7 @@
 
         if (IsOper(target_p))
         {
-          sendto_one(source_p, form_str(RPL_TRACEOPERATOR),
+          sendto_one(source_p, form_str(source_p,RPL_TRACEOPERATOR),
                      me.name, parv[0], class_name, name, 
                      MyOper(source_p) ? ipaddr :
 		     (IsIPSpoof(target_p) ? "255.255.255.255" : ipaddr),
@@ -177,7 +178,7 @@
         }
         else
         {
-          sendto_one(source_p,form_str(RPL_TRACEUSER),
+          sendto_one(source_p,form_str(source_p,RPL_TRACEUSER),
                      me.name, parv[0], class_name, name, 
                      MyOper(source_p) ? ipaddr : 
 		     (IsIPSpoof(target_p) ? "255.255.255.255" : ipaddr),
@@ -186,7 +187,7 @@
         }
       }
       
-      sendto_one(source_p, form_str(RPL_ENDOFTRACE),me.name,
+      sendto_one(source_p, form_str(source_p,RPL_ENDOFTRACE),me.name,
                  parv[0], tname);
       return;
     }
@@ -266,24 +267,24 @@
        * left here in case that should ever change --fl
        */
       if(!cnt)
-	sendto_one(source_p, form_str(RPL_TRACESERVER),
+	sendto_one(source_p, form_str(source_p,RPL_TRACESERVER),
 	           me.name, parv[0], 0, link_s[me.localClient->fd],
 		   link_u[me.localClient->fd], me.name, "*", "*", me.name);
 		   
       /* let the user have some idea that its at the end of the
        * trace
        */
-      sendto_one(source_p, form_str(RPL_ENDOFTRACE),me.name,
+      sendto_one(source_p, form_str(source_p,RPL_ENDOFTRACE),me.name,
                  parv[0],tname);
       return;
     }
     
   for (cltmp = ClassList; doall && cltmp; cltmp = cltmp->next)
     if (Links(cltmp) > 0)
-      sendto_one(source_p, form_str(RPL_TRACECLASS), me.name,
+      sendto_one(source_p, form_str(source_p,RPL_TRACECLASS), me.name,
                  parv[0], ClassName(cltmp), Links(cltmp));
 		 
-  sendto_one(source_p, form_str(RPL_ENDOFTRACE),me.name, parv[0],tname);
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFTRACE),me.name, parv[0],tname);
 }
 
 
@@ -296,6 +297,8 @@
 ms_trace(struct Client *client_p, struct Client *source_p,
 	 int parc, char *parv[])
 {
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+
   if (hunt_server(client_p, source_p, ":%s TRACE %s :%s", 2, parc, parv))
     return;
 
@@ -331,14 +334,14 @@
   switch(target_p->status)
     {
     case STAT_CONNECTING:
-      sendto_one(source_p, form_str(RPL_TRACECONNECTING), me.name,
+      sendto_one(source_p, form_str(source_p,RPL_TRACECONNECTING), me.name,
                  source_p->name, class_name, 
 		 IsOperAdmin(source_p) ? name : target_p->name);
 		   
       cnt++;
       break;
     case STAT_HANDSHAKE:
-      sendto_one(source_p, form_str(RPL_TRACEHANDSHAKE), me.name,
+      sendto_one(source_p, form_str(source_p,RPL_TRACEHANDSHAKE), me.name,
                  source_p->name, class_name, 
                  IsOperAdmin(source_p) ? name : target_p->name);
 		   
@@ -348,7 +351,7 @@
       break;
     case STAT_UNKNOWN:
       /* added time -Taner */
-      sendto_one(source_p, form_str(RPL_TRACEUNKNOWN),
+      sendto_one(source_p, form_str(source_p,RPL_TRACEUNKNOWN),
 		 me.name, source_p->name, class_name, name, ip,
 		 target_p->firsttime ? CurrentTime - target_p->firsttime : -1);
       cnt++;
@@ -363,7 +366,7 @@
 	{
 #ifndef HIDE_SPOOF_IPS
           if (IsAdmin(target_p))
-	    sendto_one(source_p, form_str(RPL_TRACEOPERATOR),
+	    sendto_one(source_p, form_str(source_p,RPL_TRACEOPERATOR),
                        me.name, source_p->name, class_name, name,
                        IsOperAdmin(source_p) ? ip : "255.255.255.255",
                        CurrentTime - target_p->lasttime,
@@ -372,7 +375,7 @@
 	  else 
 #endif
           if (IsOper(target_p))
-	    sendto_one(source_p, form_str(RPL_TRACEOPERATOR),
+	    sendto_one(source_p, form_str(source_p,RPL_TRACEOPERATOR),
 		       me.name, source_p->name, class_name, name, 
 #ifdef HIDE_SPOOF_IPS
 		       IsIPSpoof(target_p) ? "255.255.255.255" : ip,
@@ -384,7 +387,7 @@
 		       (target_p->user)?(CurrentTime - target_p->user->last):0);
 		       
 	  else
-	    sendto_one(source_p, form_str(RPL_TRACEUSER),
+	    sendto_one(source_p, form_str(source_p,RPL_TRACEUSER),
 		       me.name, source_p->name, class_name, name,
 #ifdef HIDE_SPOOF_IPS
                        IsIPSpoof(target_p) ? "255.255.255.255" : ip,
@@ -401,7 +404,7 @@
       if(!IsOperAdmin(source_p))
         name = get_client_name(target_p, MASK_IP);
 
-      sendto_one(source_p, form_str(RPL_TRACESERVER),
+      sendto_one(source_p, form_str(source_p,RPL_TRACESERVER),
 		 me.name, source_p->name, class_name, link_s_p,
 		 link_u_p, name, *(target_p->serv->by) ?
 		 target_p->serv->by : "*", "*",
@@ -410,7 +413,7 @@
       break;
       
     default: /* ...we actually shouldn't come here... --msa */
-      sendto_one(source_p, form_str(RPL_TRACENEWTYPE), me.name,
+      sendto_one(source_p, form_str(source_p,RPL_TRACENEWTYPE), me.name,
 		 source_p->name, name);
       cnt++;
       break;
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_unkline.c ircd-hybrid-7-bg/modules/m_unkline.c
--- ircd-hybrid-7rc5/modules/m_unkline.c	Thu Sep 19 00:22:55 2002
+++ ircd-hybrid-7-bg/modules/m_unkline.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_unkline.c,v 1.48 2002/09/19 04:22:55 bill Exp $
+ *  $Id: m_unkline.c,v 1.4 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -37,6 +37,7 @@
 #include "s_conf.h"
 #include "s_log.h"
 #include "s_misc.h"
+#include "s_serv.h"
 #include "send.h"
 #include "msg.h"
 #include "s_gline.h"
@@ -50,7 +51,7 @@
 
 struct Message msgtabs[] = {
   {"UNKLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
-   {m_unregistered, m_not_oper, m_error, mo_unkline}},
+   {m_unregistered, m_not_oper, mo_unkline, mo_unkline}},
   {"UNDLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
    {m_unregistered, m_not_oper, m_error, mo_undline}}, 
   {"UNGLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
@@ -73,7 +74,7 @@
   mod_del_cmd(&msgtabs[1]);
   mod_del_cmd(&msgtabs[2]);
 }
-const char *_version = "$Revision: 1.48 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 
 static int flush_write(struct Client *, FBFILE* , char *, char *);
@@ -87,8 +88,8 @@
 **
 **      parv[0] = sender
 **      parv[1] = address to remove
-*
-*
+*		parv[2] = "ON"
+*		parv[3] = remote server
 */
 static void mo_unkline (struct Client *client_p,struct Client *source_p,
                        int parc,char *parv[])
@@ -98,9 +99,15 @@
   char buf[BUFSIZE], buff[BUFSIZE], temppath[BUFSIZE], *user, *host, *p;
   const char  *filename;                /* filename to use for unkline */
   mode_t oldumask;
+  
+  if (IsServer(client_p))
+  if (ServerInfo.gateway && get_bridge_token(client_p))
+  	return;
 
   ircsprintf(temppath, "%s.tmp", ConfigFileEntry.klinefile);
   
+  if (MyClient(source_p)) 
+  {
   if (!IsOperUnkline(source_p))
     {
       sendto_one(source_p,":%s NOTICE %s :You need unkline = yes;",me.name,parv[0]);
@@ -108,10 +115,11 @@
     }
   if (parc < 2)
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, source_p->name, "UNKLINE");
       return;
     }
+  }
 
   if ((host = strchr(parv[1], '@')) || *parv[1] == '*')
     {
@@ -134,6 +142,26 @@
                  me.name, source_p->name);
       return;
     }
+    
+  if ((parc > 3) && !irccmp(parv[2], "ON")) 
+  {
+	sendto_server(NULL, source_p, NULL, CAP_KLN, NOCAPS, LL_ICLIENT,
+                    ":%s UNKLINE %s@%s ON %s",
+                    source_p->name, 
+                    user, host, 
+                    parv[3]);
+
+      /* If we are sending it somewhere that doesnt include us, we stop
+       * else we apply it locally too
+       */
+	if (!match(parv[3], me.name))
+		return;
+
+	if (!MyClient(source_p))
+	if (!find_u_conf((char *)source_p->user->server, 
+		source_p->username, source_p->host))
+		return;
+  }
 
   if (remove_tkline_match(host, user))
     {
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_user.c ircd-hybrid-7-bg/modules/m_user.c
--- ircd-hybrid-7rc5/modules/m_user.c	Fri May 24 19:34:23 2002
+++ ircd-hybrid-7-bg/modules/m_user.c	Mon Mar 10 01:09:02 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_user.c,v 1.23 2002/05/24 23:34:23 androsyn Exp $
+ *  $Id: m_user.c,v 1.2 2003/03/10 06:09:02 demond Exp $
  */
 
 #include "stdinc.h"
@@ -58,7 +58,7 @@
   mod_del_cmd(&user_msgtab);
 }
 
-const char *_version = "$Revision: 1.23 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
 ** mr_user
@@ -78,7 +78,7 @@
 
   if (*parv[4] == '\0')
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, BadPtr(parv[0]) ? "*" : parv[0], "USER");
       return;
     }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_userhost.c ircd-hybrid-7-bg/modules/m_userhost.c
--- ircd-hybrid-7rc5/modules/m_userhost.c	Fri May 24 19:34:23 2002
+++ ircd-hybrid-7-bg/modules/m_userhost.c	Mon Mar 10 01:09:02 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_userhost.c,v 1.37 2002/05/24 23:34:23 androsyn Exp $
+ *  $Id: m_userhost.c,v 1.2 2003/03/10 06:09:02 demond Exp $
  */
 
 #include "stdinc.h"
@@ -57,7 +57,7 @@
   mod_del_cmd(&userhost_msgtab);
 }
 
-const char *_version = "$Revision: 1.37 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * m_userhost added by Darren Reed 13/8/91 to aid clients and reduce
@@ -76,7 +76,10 @@
   int cur_len;
   int rl;
 
-  cur_len = ircsprintf(buf,form_str(RPL_USERHOST),me.name, parv[0], "");
+  if (client_p->user) 
+	  client_p->user->known = 1;
+
+  cur_len = ircsprintf(buf,form_str(source_p,RPL_USERHOST),me.name, parv[0], "");
   t = buf + cur_len;
 
   for ( i = 0; i < 5; i++)
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_users.c ircd-hybrid-7-bg/modules/m_users.c
--- ircd-hybrid-7rc5/modules/m_users.c	Fri May 24 19:34:23 2002
+++ ircd-hybrid-7-bg/modules/m_users.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_users.c,v 1.25 2002/05/24 23:34:23 androsyn Exp $
+ *  $Id: m_users.c,v 1.4 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -33,6 +33,7 @@
 #include "msg.h"
 #include "parse.h"
 #include "modules.h"
+#include "s_misc.h"
 
 static void m_users(struct Client*, struct Client*, int, char**);
 static void mo_users(struct Client*, struct Client*, int, char**);
@@ -55,7 +56,7 @@
   mod_del_cmd(&users_msgtab);
 }
 
-const char *_version = "$Revision: 1.25 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 
 /*
@@ -72,12 +73,15 @@
       return;
   }
     
-  sendto_one(source_p, form_str(RPL_LOCALUSERS), me.name, parv[0],
+  sendto_one(source_p, form_str(source_p,RPL_LOCALUSERS), me.name, parv[0],
              ConfigServerHide.hide_servers ? Count.total : Count.local, 
 	     ConfigServerHide.hide_servers ? Count.max_tot : Count.max_loc);
 
-  sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
-                 Count.total, Count.max_tot);
+  sendto_one(source_p, form_str(source_p,RPL_GLOBALUSERS), me.name, parv[0],
+             Count.total, Count.max_tot);
+
+  sendto_one(source_p, form_str(source_p,RPL_IDUSERS), me.name, parv[0],
+             Count.identified, Count.max_identified);
 }
 
 /*
@@ -88,17 +92,22 @@
 static void mo_users(struct Client *client_p, struct Client *source_p,
                    int parc, char *parv[])
 {
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+
   if (hunt_server(client_p,source_p,":%s USERS :%s",1,parc,parv) == HUNTED_ISME)
     {
       if(!IsOper(source_p) && ConfigServerHide.hide_servers)
-        sendto_one(source_p, form_str(RPL_LOCALUSERS), me.name, parv[0],
+        sendto_one(source_p, form_str(source_p,RPL_LOCALUSERS), me.name, parv[0],
                    Count.total, Count.max_tot);
       else
-        sendto_one(source_p, form_str(RPL_LOCALUSERS), me.name, parv[0],
+        sendto_one(source_p, form_str(source_p,RPL_LOCALUSERS), me.name, parv[0],
 	           Count.local, Count.max_loc);
 
-      sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
+      sendto_one(source_p, form_str(source_p,RPL_GLOBALUSERS), me.name, parv[0],
                  Count.total, Count.max_tot);
+
+      sendto_one(source_p, form_str(source_p,RPL_IDUSERS), me.name, parv[0],
+                 Count.identified, Count.max_identified);
     }
 }
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_version.c ircd-hybrid-7-bg/modules/m_version.c
--- ircd-hybrid-7rc5/modules/m_version.c	Wed Jul 17 19:09:10 2002
+++ ircd-hybrid-7-bg/modules/m_version.c	Sat May 24 23:27:10 2003
@@ -19,10 +19,11 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_version.c,v 1.39 2002/07/17 23:09:10 leeh Exp $
+ *  $Id: m_version.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
-#include <stdinc.h>
+#include "stdinc.h"
+#include "config.h"
 #include "handlers.h"
 #include "client.h"
 #include "ircd.h"
@@ -34,6 +35,7 @@
 #include "msg.h"
 #include "parse.h"
 #include "modules.h"
+#include "s_misc.h"
 
 static char* confopts(struct Client *source_p);
 
@@ -59,7 +61,7 @@
   mod_del_cmd(&version_msgtab);
 }
 
-const char *_version = "$Revision: 1.39 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_version - VERSION command handler
@@ -74,7 +76,7 @@
   if((last_used + ConfigFileEntry.pace_wait) > CurrentTime)
   {
     /* safe enough to give this on a local connect only */
-    sendto_one(source_p,form_str(RPL_LOAD2HI),me.name,parv[0]);
+    sendto_one(source_p,form_str(source_p,RPL_LOAD2HI),me.name,parv[0]);
     return;
   }
   else
@@ -89,7 +91,7 @@
       return;
   }
   
-  sendto_one(source_p, form_str(RPL_VERSION), me.name,
+  sendto_one(source_p, form_str(source_p,RPL_VERSION), me.name,
                 parv[0], ircd_version, serno, debugmode,
                 me.name, confopts(source_p), serveropts);
                 
@@ -109,7 +111,7 @@
 		  1, parc, parv) != HUNTED_ISME)
     return;
     
-  sendto_one(source_p, form_str(RPL_VERSION), me.name, parv[0], ircd_version, 
+  sendto_one(source_p, form_str(source_p,RPL_VERSION), me.name, parv[0], ircd_version, 
   	     serno, debugmode, me.name, confopts(source_p), serveropts);
 	       
   show_isupport(source_p);
@@ -125,10 +127,12 @@
 static void ms_version(struct Client* client_p, struct Client* source_p,
                       int parc, char* parv[])
 {
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+
   if (hunt_server(client_p, source_p, ":%s VERSION :%s", 
                   1, parc, parv) == HUNTED_ISME)
   {
-    sendto_one(source_p, form_str(RPL_VERSION), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_VERSION), me.name,
                parv[0], ircd_version, serno, debugmode,
                me.name, confopts(source_p), serveropts);
     show_isupport(source_p);
@@ -144,7 +148,7 @@
  */
 static char* confopts(struct Client *source_p)
 {
-  static char result[15];
+  static char result[32];
   char *p;
   
   result[0] = '\0';
@@ -154,6 +158,12 @@
   *p++ = 'D';
 #endif
 
+  if (ConfigFileEntry.cyrillic)
+    *p++ = 'c';
+
+  if (ConfigChannel.use_denies)
+    *p++ = 'd';
+
   if(ConfigChannel.use_except)
     *p++ = 'e';
     
@@ -168,16 +178,32 @@
       *p++ = 'H';
     }
 
+  if (ServerInfo.gateway && 
+      (!ConfigServerHide.disable_remote || IsOper(source_p)) )
+    {
+      *p++ = 'B';
+    }
+
   if(ConfigChannel.use_invex)
     *p++ = 'I';
 
+  if(ConfigChannel.use_subst)
+    *p++ = 'S';
+
+  if (ConfigFileEntry.drone_kline)
+	*p++ = ConfigFileEntry.drone_batch? 'k' : 'K';
+
   if(ConfigChannel.use_knock)
-    *p++ = 'K';
+    *p++ = 'L';
     
   *p++ = 'M';
 
 #ifdef CRYPT_OPER_PASSWORD
   *p++ = 'p';
+#endif
+
+#ifdef USEPACE
+  *p++ = 'P';
 #endif
 
 #ifdef IGNORE_BOGUS_TS
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_wallops.c ircd-hybrid-7-bg/modules/m_wallops.c
--- ircd-hybrid-7rc5/modules/m_wallops.c	Fri May 24 19:34:23 2002
+++ ircd-hybrid-7-bg/modules/m_wallops.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_wallops.c,v 1.29 2002/05/24 23:34:23 androsyn Exp $
+ *  $Id: m_wallops.c,v 1.4 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -35,6 +35,7 @@
 #include "parse.h"
 #include "modules.h"
 #include "client.h"
+#include "s_misc.h"
 
 static void ms_wallops(struct Client*, struct Client*, int, char**);
 static void mo_wallops(struct Client*, struct Client*, int, char**);
@@ -57,7 +58,7 @@
   mod_del_cmd(&wallops_msgtab);
 }
  
-const char *_version = "$Revision: 1.29 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 /*
  * mo_wallops (write to *all* opers currently online)
@@ -73,12 +74,12 @@
   
   if (EmptyString(message))
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "WALLOPS");
       return;
     }
 
-  sendto_wallops_flags(FLAGS_OPERWALL, source_p, "OPERWALL - %s", message);
+  sendto_wallops_flags(FLAGS_OPERWALL, source_p, "[W] %s", message);
   sendto_server(NULL, source_p, NULL, NOCAPS, NOCAPS, LL_ICLIENT,
                 ":%s WALLOPS :%s", parv[0], message);
 }
@@ -92,18 +93,20 @@
                       int parc, char *parv[])
 { 
   char* message;
+  
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
 
   message = parv[1];
   
   if (EmptyString(message))
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "WALLOPS");
       return;
     }
 
   if(IsClient(source_p))
-    sendto_wallops_flags(FLAGS_OPERWALL, source_p, "OPERWALL - %s", message);
+    sendto_wallops_flags(FLAGS_OPERWALL, source_p, "[W] %s", message);
   else
     sendto_wallops_flags(FLAGS_WALLOP, source_p, "%s", message); 
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_watch.c ircd-hybrid-7-bg/modules/m_watch.c
--- ircd-hybrid-7rc5/modules/m_watch.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-7-bg/modules/m_watch.c	Mon Mar 10 01:09:02 2003
@@ -0,0 +1,244 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_watch.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_watch.c,v 1.3 2003/03/10 06:09:02 demond Exp $
+ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "s_log.h"
+#include "s_misc.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void m_watch(struct Client*, struct Client*, int, char**);
+static void show_watch(aClient *cptr, char *name, int rpl1, int rpl2);
+
+struct Message watch_msgtab = {
+  "WATCH", 0, 0, 0, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_watch, m_ignore, m_watch}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&watch_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&watch_msgtab);
+}
+
+const char *_version = "$Revision: 1.3 $";
+#endif
+
+/*
+ *	shamelessly stolen from bahamut				
+ *						-demond
+ */
+
+static char buf[BUFSIZE];
+
+/*
+ * RPL_NOWON   - Online at the moment (Succesfully added to WATCH-list)
+ * RPL_NOWOFF  - Offline at the moement (Succesfully added to WATCH-list)
+ * RPL_WATCHOFF   - Succesfully removed from WATCH-list.
+ * ERR_TOOMANYWATCH - Take a guess :>  Too many WATCH entries.
+ */
+static void show_watch(aClient *cptr, char *name, int rpl1, int rpl2) 
+{
+    aClient *acptr;	
+    
+    if ((acptr = find_person(name)))
+	sendto_one(cptr, form_str(cptr,rpl1), me.name, cptr->name,
+		   acptr->name, acptr->username,
+		   acptr->host, acptr->lasttime);
+    else
+	sendto_one(cptr, form_str(cptr,rpl2), me.name, cptr->name,
+		   name, "*", "*", 0);
+}
+	
+/* m_watch */
+static void m_watch(aClient *cptr, aClient *sptr, int parc, char *parv[]) 
+{
+    aClient  *acptr;
+    char  *s, *p, *user;
+    char def[2] = "l";
+	int i;
+	
+    if (parc < 2) 
+    {
+	/* Default to 'l' - list who's currently online */
+	parc = 2;
+	parv[1] = def;
+    }
+    
+    /*for (p = NULL, s = strtoken(&p, parv[1], ", "); s;
+	 s = strtoken(&p, NULL, ", "))*/
+	/*                                                */
+	/* this works on bahamut only...                  */
+	/*                                  -demond       */
+	/*                                                */
+	for (i = 1, s = parv[1]; i < parc; s = parv[++i])
+    {
+	if ((user = (char *)strchr(s, '!')))
+	    *user++ = '\0'; /* Not used */
+		
+	/*
+	 * Prefix of "+", they want to add a name to their WATCH
+	 * list. 
+	 */
+	if (*s == '+') 
+	{
+	    if (*(s+1)) 
+	    {
+		if (sptr->watches >= MAXWATCH) 
+		{
+		    sendto_one(sptr, form_str(sptr,ERR_TOOMANYWATCH),
+			       me.name, cptr->name, s+1);					
+		    continue;
+		}				
+		add_to_watch_hash_table(s+1, sptr);
+	    }
+	    show_watch(sptr, s+1, RPL_NOWON, RPL_NOWOFF);
+	    continue;
+	}
+	
+	/*
+	 * Prefix of "-", coward wants to remove somebody from their
+	 * WATCH list.  So do it. :-)
+	 */
+	if (*s == '-') 
+	{
+	    del_from_watch_hash_table(s+1, sptr);
+	    show_watch(sptr, s+1, RPL_WATCHOFF, RPL_WATCHOFF);
+	    continue;
+	}
+					
+	/*
+	 * Fancy "C" or "c", they want to nuke their WATCH list and start
+	 * over, so be it.
+	 */
+	if (*s == 'C' || *s == 'c') 
+	{
+	    hash_del_watch_list(sptr);
+	    continue;
+	}
+		
+	/*
+	 * Now comes the fun stuff, "S" or "s" returns a status report of
+	 * their WATCH list.  I imagine this could be CPU intensive if its
+	 * done alot, perhaps an auto-lag on this?
+	 */
+	if (*s == 'S' || *s == 's') 
+	{
+	    Link *lp;
+	    aWatch *anptr;
+	    int  count = 0;
+							
+	    /*
+	     * Send a list of how many users they have on their WATCH list
+	     * and how many WATCH lists they are on.
+	     */
+	    anptr = hash_get_watch(sptr->name);
+	    if (anptr)
+		for (lp = anptr->watch, count = 1; (lp = lp->next); count++);
+	    sendto_one(sptr, form_str(sptr,RPL_WATCHSTAT), me.name, parv[0],
+		       sptr->watches, count);
+			
+	    /*
+	     * Send a list of everybody in their WATCH list. Be careful
+	     * not to buffer overflow.
+	     */
+	    if ((lp = sptr->watch) == NULL) 
+	    {
+		sendto_one(sptr, form_str(sptr,RPL_ENDOFWATCHLIST), me.name, parv[0],
+			   *s);
+		continue;
+	    }
+	    *buf = '\0';
+	    strcpy(buf, lp->value.wptr->nick);
+	    count = strlen(parv[0])+strlen(me.name)+10+strlen(buf);
+	    while ((lp = lp->next)) 
+	    {
+		if (count+strlen(lp->value.wptr->nick)+1 > BUFSIZE - 2) 
+		{
+		    sendto_one(sptr, form_str(sptr,RPL_WATCHLIST), me.name,
+			       parv[0], buf);
+		    *buf = '\0';
+		    count = strlen(parv[0])+strlen(me.name)+10;
+		}
+		strcat(buf, " ");
+		strcat(buf, lp->value.wptr->nick);
+		count += (strlen(lp->value.wptr->nick)+1);
+	    }
+	    sendto_one(sptr, form_str(sptr,RPL_WATCHLIST), me.name, parv[0], buf);
+	    sendto_one(sptr, form_str(sptr,RPL_ENDOFWATCHLIST), me.name, parv[0],
+		       *s);
+	    continue;
+	}
+		
+	/*
+	 * Well that was fun, NOT.  Now they want a list of everybody in
+	 * their WATCH list AND if they are online or offline? Sheesh,
+	 * greedy arn't we?
+	 */
+	if (*s == 'L' || *s == 'l') 
+	{
+	    Link *lp = sptr->watch;
+			
+	    while (lp) 
+	    {
+		if ((acptr = find_person(lp->value.wptr->nick)))
+		    sendto_one(sptr, form_str(sptr,RPL_NOWON), me.name, parv[0],
+			       acptr->name, acptr->username,
+			       acptr->host, acptr->tsinfo);
+		/*
+		 * But actually, only show them offline if its a capital
+		 * 'L' (full list wanted).
+		 */
+		else if (isupper(*s))
+		    sendto_one(sptr, form_str(sptr,RPL_NOWOFF), me.name, parv[0],
+			       lp->value.wptr->nick, "*", "*",
+			       lp->value.wptr->lasttime);
+		lp = lp->next;
+	    }
+			
+	    sendto_one(sptr, form_str(sptr,RPL_ENDOFWATCHLIST), me.name, parv[0],
+		       *s);
+	    continue;
+	}
+	/* Hmm.. unknown prefix character.. Ignore it. :-) */
+    }
+	
+    /*return 0;*/
+}
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_who.c ircd-hybrid-7-bg/modules/m_who.c
--- ircd-hybrid-7rc5/modules/m_who.c	Wed Oct 16 16:52:34 2002
+++ ircd-hybrid-7-bg/modules/m_who.c	Mon Mar 10 01:09:02 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_who.c,v 1.66 2002/10/16 20:52:34 bill Exp $
+ *  $Id: m_who.c,v 1.2 2003/03/10 06:09:02 demond Exp $
  */
 #include "stdinc.h"
 #include "tools.h"
@@ -61,7 +61,7 @@
 {
   mod_del_cmd(&who_msgtab);
 }
-const char *_version = "$Revision: 1.66 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 static void do_who_on_channel(struct Client *source_p,
 			      struct Channel *chptr, char *real_name,
@@ -112,6 +112,9 @@
   struct Channel *vchan;
 #endif
 
+  if (client_p->user) 
+	  client_p->user->known = 1;
+
   /* See if mask is there, collapse it or return if not there */
 
   if (mask != NULL)
@@ -120,14 +123,14 @@
 
       if (*mask == '\0')
 	{
-	  sendto_one(source_p, form_str(RPL_ENDOFWHO), me.name, parv[0], "*");
+	  sendto_one(source_p, form_str(source_p,RPL_ENDOFWHO), me.name, parv[0], "*");
 	  return;
 	}
     }
   else
     {
       who_global(source_p, mask, server_oper);
-      sendto_one(source_p, form_str(RPL_ENDOFWHO), me.name, parv[0], "*" );
+      sendto_one(source_p, form_str(source_p,RPL_ENDOFWHO), me.name, parv[0], "*" );
       return;
     }
 
@@ -143,7 +146,7 @@
 
       if (!mychannel)
         {
-          sendto_one(source_p, form_str(RPL_ENDOFWHO), me.name, parv[0], "*");
+          sendto_one(source_p, form_str(source_p,RPL_ENDOFWHO), me.name, parv[0], "*");
           return;
         }
 
@@ -160,7 +163,7 @@
 #endif
 	do_who_on_channel(source_p, mychannel, "*", NO, YES);
 
-      sendto_one(source_p, form_str(RPL_ENDOFWHO), me.name, parv[0], "*");
+      sendto_one(source_p, form_str(source_p,RPL_ENDOFWHO), me.name, parv[0], "*");
       return;
     }
 
@@ -199,7 +202,7 @@
 		do_who_on_channel(source_p, chptr, chptr->chname, NO, NO);
 	    }
 	}
-      sendto_one(source_p, form_str(RPL_ENDOFWHO), me.name, parv[0], mask);
+      sendto_one(source_p, form_str(source_p,RPL_ENDOFWHO), me.name, parv[0], mask);
       return;
     }
 
@@ -267,7 +270,7 @@
 	  do_who(source_p, target_p, NULL, "");
 	}
 
-      sendto_one(source_p, form_str(RPL_ENDOFWHO), me.name, parv[0], mask);
+      sendto_one(source_p, form_str(source_p,RPL_ENDOFWHO), me.name, parv[0], mask);
       return;
     }
 
@@ -278,7 +281,7 @@
     who_global(source_p, mask, server_oper);
 
  /* Wasn't a nick, wasn't a channel, wasn't a '*' so ... */
-  sendto_one(source_p, form_str(RPL_ENDOFWHO), me.name, parv[0], mask);
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFWHO), me.name, parv[0], mask);
 }
 
 /* who_common_channel
@@ -570,7 +573,7 @@
 #ifdef ANONOPS
   if(ConfigServerHide.hide_servers)
   {
-    sendto_one(source_p, form_str(RPL_WHOREPLY), me.name, source_p->name,
+    sendto_one(source_p, form_str(source_p,RPL_WHOREPLY), me.name, source_p->name,
 	       (chname) ? (chname) : "*",
 	       target_p->username,
 	       target_p->host, IsOper(source_p) ? target_p->user->server : "*",
@@ -580,7 +583,7 @@
   else
 #endif
   {
-    sendto_one(source_p, form_str(RPL_WHOREPLY), me.name, source_p->name,
+    sendto_one(source_p, form_str(source_p,RPL_WHOREPLY), me.name, source_p->name,
 	       (chname) ? (chname) : "*",
 	       target_p->username,
 	       target_p->host,  target_p->user->server, target_p->name,
